Foreman - Bug #2343

app/models/setting.rb#default chokes on nil attributes
03/20/2013 03:32 AM - David Schmitt

Status: Closed

Priority: Normal
Assignee: Toma$ Strachota
Category:

Target version: 1.2.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

On a freshly installed wheezy with the 1.1.1+debian1 packages from deb.theforeman.org, | get the following trace:

rake aborted!

can't convert nil into String

/usr/lib/ruby/1.9.1/psych.rb:203:in ‘“parse'
/usr/lib/ruby/1.9.1/psych.rb:203:in ‘parse_stream'
/usr/lib/ruby/1.9.1/psych.rb:151:in “parse'
/usr/lib/ruby/1.9.1/psych.rb:127:in "~ load'

/usr/share/foreman/app/models/setting.rb:77:in “default'
/usr/share/foreman/app/models/setting.rb:63:in “value="

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/base.rb:1569:in b
lock in attributes='
/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/base.rb:1565:in ‘e
ach'
/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/base.rb:1565:in “a
ttributes="
/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/base.rb:1416:in i
nitialize'
/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/validations.rb:32:
in “new'
/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/validations.rb:32:
in “create!'

/usr/share/foreman/lib/foreman/default_settings/loader.rb:21:in " create'
/usr/share/foreman/lib/foreman/default_settings/loader.rb:77:in “block (2 levels) in load'
/usr/share/foreman/lib/foreman/default_settings/loader.rb:61l:in “each'
/usr/share/foreman/lib/foreman/default_settings/loader.rb:61:in "block in load'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/connection_adapter

s/abstract/database_statements.rb:139:in "transaction'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.0.20/1ib/active_record/transactions.rb:20

7:in “transaction'’

/usr/share/foreman/lib/foreman/default_settings/loader.rb:33:in "~ load'

/usr/share/foreman/config/initializers/foreman.rb:4:in " <top

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.

236:in "~ load'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.

236:in "block in load'
/usr/share/foreman/vendor/ruby/1.9.
227:in "~ load_dependency'
/usr/share/foreman/vendor/ruby/1.9.
236:in "load'
/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.
els)
/usr/share/foreman/vendor/ruby/1.9.
/usr/share/foreman/vendor/ruby/1.9.
ass:Engine>"
/usr/share/foreman/vendor/ruby/1.9.

in <class:Engine>"'
1/gems/railties-3.
1/gems/railties-3.

1/gems/railties-3.
1/gems/activesupport-3.
1/gems/activesupport-3.
0.20/1ib/rails/engine.rb:201:

0.20/1ib/rails/engine.rb:200:
0.20/1ib/rails/engine.rb:200:

0.20/1ib/rails/initializable.

(required)>"'

0.20/1ib/active_support/dependencies.rb:

0.20/1ib/active_support/dependencies.rb:

0.20/1lib/active_support/dependencies.rb:

0.20/1ib/active_support/dependencies.rb:

in “block (2 lev

“each'
"block in <cl

in
in

rb:25:1in “instan

1/3




ce_exec'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/initializable.rb:25:
/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/initializable.rb:50:

in run_initializers'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/initializable.rb:49:
/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/initializable.rb:49:

itializers'

in
in
in
in

“run'
"block

“each'
‘run_in

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/application.rb:134:in ‘initial

izel!!

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.0.20/1ib/rails/application.rb:77:in ‘method_m

issing'

/usr/share/foreman/config/environment.rb:5:in “<top (required)>"'
[...]

I've added debugging to the "default" method and it dies with "modulepath is nil".

Returning nil instead of raising an exception let the db:migrate run through.

Related issues:

Related to Foreman - Refactor #2660: Setting model, improve tests, string par... Closed
Related to Foreman - Bug #2686: foreman-config doesn't change boolean settings Closed
Has duplicate Foreman - Bug #3472: "instance of 10 needed" failure on new ins... Duplicate

06/12/2013
06/20/2013
10/22/2013

Associated revisions

Revision 911d3f5c - 06/12/2013 11:11 AM - Tomas Strachota
fixes #2343 - override default settings with custom values
- added check for nil before attribute 'default’ is loaded from yaml

- removed logic that tried to set 'value' attr to nil when it was equal to 'default’;
it didn't behave predictably as 'default' can be assigned after 'value'

Revision ec57fff6 - 06/12/2013 04:11 PM - Tomas Strachota

fixes #2343 - override default settings with custom values

- added check for nil before attribute 'default' is loaded from yaml

- removed logic that tried to set 'value' attr to nil when it was equal to 'default’;

it didn't behave predictably as 'default' can be assigned after 'value'
(cherry picked from commit 911d3f5c8f68d7a6daf89296b92af37d546ce95a)

History

#1 - 03/20/2013 01:51 PM - Dominic Cleal

- Status changed from New to Feedback

I'm struggling to work out how this happened, since modulepath has a fixed string as a default.

Are you able to check that default is initialised here? lib/foreman/default_settings/loader.rb:21:in “create'

#2 - 03/25/2013 03:44 AM - David Schmitt

So, | finally got around to digging deeper into this issue. After playing around with the issue, | noticed that it does not hang on the specific setting, but |
can trigger it by setting the value in the settings.yaml. e.g. adding ":administrator: foo@example.com" there, leads to this trace (line numbers may be

fuzzy due to debug puts):

foreman@puppetmaster:~$ RAILS_ENV=production rake db:migrate --trace
** Invoke db:migrate (first_time)

** Invoke environment (first_time)

** Execute environment

{:name=>"administrator", :value=>"fool@example.com", :description=>"The default administrator email address",

default=>"root@example.org", :category=>"General"}
reading administrator's default: nil

rake aborted!

can't convert nil into String
/usr/lib/ruby/1.9.1/psych.rb:203:in “parse’
/usr/lib/ruby/1.9.1/psych.rb:203:in "parse_stream'
/usr/lib/ruby/1.9.1/psych.rb:151:in ‘parse'
/usr/lib/ruby/1.9.1/psych.rb:127:in "~ load'
/usr/share/foreman/app/models/setting.rb:78:in “default'
/usr/share/foreman/app/models/setting.rb:63:in “value='
mailto:foo@example.com

/usr/share/foreman/vendor/ruby/1.
ibutes="

/usr/share/foreman/vendor/ruby/1.
/usr/share/foreman/vendor/ruby/1.
/usr/share/foreman/vendor/ruby/1.
/usr/share/foreman/vendor/ruby/1.
/usr/share/foreman/vendor/ruby/1.
/usr/share/foreman/lib/foreman/default_settings/loader.
/usr/share/foreman/lib/foreman/default_settings/loader.
/usr/share/foreman/lib/foreman/default_settings/loader.
/usr/share/foreman/lib/foreman/default_settings/loader.

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-

atabase_statements.rb:139:in "~ transaction’'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-

ction'
/usr/share/foreman/lib/foreman/default_settings/loader.
/usr/share/foreman/config/initializers/foreman.rb:4:1in

fooo]

Accordingly, | can make this all go away, by setting opts[:value] = nil in the
bit".

.1/gems/activerecord-

.1/gems/activerecord-
.1/gems/activerecord-
.1/gems/activerecord-
.1/gems/activerecord-
.1/gems/activerecord-

3.0.20/1ib/active_record/base.rb:1569:in “block in attr
3.0.20/1ib/active_record/base.rb:1565:in ‘each'
3.0.20/1ib/active_record/base.rb:1565:in “attributes="'
3.0.20/1ib/active_record/base.rb:1416:in “initialize’
3.0.20/1ib/active_record/validations.rb:32:in "new'
3.0.20/1ib/active_record/validations.rb:32:in “create!’
rb:22:in “create'

rb:45:in “block (2 levels) in load'

rb:37:in "“each'

rb:37:in “block in load'

3.0.20/1ib/active_record/connection_adapters/abstract/d
3.0.20/1ib/active_record/transactions.rb:207:in "transa
rb:34:in "~ load'

"<top (required)>"'

default_settings/loader/create method. Of course, this breaks the install "a

Another thing | noticed, but can't categorize: When | recreate the database, the first rake db:migrate initializes all the tables, but it requires a second

db:migrate run to start loading the settings.

Ah, finally found it! app/models/setting.rb#value= checks whether val == default before setting the value. Since at create! time the setting has no

default yet (it will be only written to it a few moments later), it fails. Hard.

Now | need to figure out a way to hotfix that in my automated install until this fix is released ;-)

#3 - 04/07/2013 08:47 AM - Dominic Cleal
- Status changed from Feedback to Assigned
- Assignee set to Dominic Cleal

- Target version set to 1.2.0

Thanks for investigating David, I've reproduced it based on that info. This happens when you set values for settings in settings.yaml, which is meant

to be supported.

#4 - 05/20/2013 12:54 PM - Dominic Cleal
- Status changed from Assigned to New

- Assignee deleted (Dominic Cleal)

#5 - 05/22/2013 02:48 AM - Tomas Strachota

- Assignee set to Tomas Strachota

#6 - 06/04/2013 03:32 AM - Dominic Cleal
- Status changed from New to Ready For Testing

https://github.com/theforeman/foreman/pull/637

#7 - 06/12/2013 11:17 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 911d3f5c8f68d7a6daf89296b92af37d546ce95a.

#8 - 10/22/2013 08:32 PM - Dominic Cleal

- Has duplicate Bug #3472: "instance of 10 needed" failure on new install added
https://github.com/theforeman/foreman/pull/637
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/911d3f5c8f68d7a6daf89296b92af37d546ce95a
http://www.tcpdf.org

